            #include <P16F676.INC>
            LIST        p=16F676  
            __CONFIG    b'11111110000100'   ; 
                                               
            
Sec           equ         20h               ;    
Sec1          equ         21h               ; 
Sec2          equ         22h               ;
varLL         equ         24h               ;  
varLH         equ         25h               ; 
tmpLL         equ         26h               ;
rezLL         equ         2Dh               ;
rezLH         equ         2Eh               ;
shet          equ         23h               ;  
bcd1          equ         27h               ;    
bcd2          equ         28h               ;  
bcd3          equ         29h               ;
sotni         equ         2Ah               ;
desiat        equ         2Bh               ;
edin          equ         2Ch               ;

adr_ind       equ         30h               ;   
dat_ind       equ         31h               ;   
scetbit       equ         32h               ;

#DEFINE       acp_on      PORTA,2           ;    
#DEFINE       datai       PORTC,2           ;    MAX7219
#DEFINE       cs          PORTC,1           ;   MAX7219
#DEFINE       clk         PORTC,0           ;   MAX7219

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

              org         0000h             ;     0000h
              goto        Start             ;   Start
           
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; 
                                              
Start         movlw       b'00000000'       ;    A
              movwf       PORTA             ;
              movlw       b'00000010'       ;    
              movwf       PORTC             ;
              
              movlw       b'00000111'       ; 
              movwf       CMCON             ;

              bsf         STATUS,RP0        ; 1-     
              movlw       b'11111011'       ;  \  
              movwf       TRISA             ;
              movlw       b'11111000'       ;  \  
              movwf       TRISC             ;
              movlw       b'01010000'       ;    (Fosc/16 = 4 )
              movwf       ADCON1            ;
              movlw       b'00000001'       ; / 
              movwf       ANSEL             ;RA0 -  
              bcf         STATUS,RP0        ; 0-   

              movlw       b'00000000'       ;  ,  AN0,  ,
              movwf       ADCON0            ;      

              call        init_lcd          ;    

Start_1       call        battery           ;       
              call        vivod             ;      
              call        pause             ;   2 
              goto        Start_1           ;   Start_1


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

vivod         movlw       0x08              ; 8- 
              movwf       adr_ind           ;
              movlw       0x0F              ;
              movwf       dat_ind           ;
              call        send              ;
              movlw       0x07              ; 7- 
              movwf       adr_ind           ;
              movlw       0x0F              ;
              movwf       dat_ind           ;
              call        send              ;
              movlw       0x06              ; 6- 
              movwf       adr_ind           ;
              movlw       0x0F              ;
              movwf       dat_ind           ;
              call        send              ;
              movlw       0x05              ; 5- 
              movwf       adr_ind           ;
              movlw       0x0F              ;
              movwf       dat_ind           ;
              call        send              ;
              movlw       0x04              ; 4- 
              movwf       adr_ind           ;
              movlw       0x0F              ;
              movwf       dat_ind           ;
              call        send              ;

              movlw       0x03              ;   sotni  3-  
              movwf       adr_ind           ;   
              movf        sotni,W           ;
              movwf       dat_ind           ;
              bsf         dat_ind,7         ;  
              call        send              ;
              movlw       0x02              ;   desiat  2- 
              movwf       adr_ind           ;   ,  
              movf        desiat,W          ; 
              movwf       dat_ind           ;
              call        send              ;
              movlw       0x01              ;   edin  1- 
              movwf       adr_ind           ;   ,  
              movf        edin,W            ; 
              movwf       dat_ind           ;
              call        send              ;
              return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

battery       bsf         acp_on            ;    (TL431)
              bsf         ADCON0,ADON       ;  
              call        pause             ;   2 
              bsf         ADCON0,GO_DONE    ;  GO_DONE,   
       
batt_1        btfsc       ADCON0,GO_DONE    ;  GO_DONE
              goto        batt_1            ; GO_DONE   0,   
                                            ;,    batt_1 
              movf        ADRESH,W          ; ,  
              movwf       tmpLL             ;  tmpLL

              bcf         acp_on            ;    (TL431)
              bcf         ADCON0,ADON       ;  

              movlw       .7                ;  62475   varLH, varLL 
              movwf       varLL             ; 
              movlw       .248              ;
              movwf       varLH             ;
              call        del               ;    62475    
              call        bin2bcd           ;        
              return                        ;   

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;      (varLH, varLL):(tmpLL)
;    rezLH, rezLL,     
;   ,      

del           clrf         rezLL            ;  rezLL, rezLH (  )
              clrf         rezLH            ;
              movlw        .0               ;       tmpLL
              xorwf        tmpLL,W          ;(   )
              btfsc        STATUS,Z         ;
              return                        ;   tmpLL  :   
                                            ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
d1            movf         tmpLL,W          ;  tmpLL   :      
              subwf        varLL,F          ;tmpLL     varLH, varLL:    
              btfsc        STATUS,C         ;   
              goto         d2               ;      
              movlw        .1               ;     
              subwf        varLH,F          ;   d2
              btfss        STATUS,C         ;
              return                        ;
                                            ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
d2            incfsz       rezLL,F          ; rezLL          
              goto         d1               ;  rezLL:    d1 
              incf         rezLH,F          ; rezLL:   rezLH ( rezLL, rezLH  
                                            ;        )
              goto         d1               ;   d1   ,  
                                            ;   
                                          
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;                            

bin2bcd       movlw       .16               ;   
              movwf       shet              ; 
              clrf        bcd1              ;   
              clrf        bcd2              ;  rezLH, rezLL
              clrf        bcd3              ; : 
              goto        bin2bcd_1         ;    bcd3
                                            ;    bcd3
adjdec        movlw       0x33              ;    bcd2
              addwf       bcd1,F            ;    bcd2
              addwf       bcd2,F            ;     bcd1
              addwf       bcd3,F            ;
                                            ;
              movlw       0x03              ;
              btfss       bcd1,3            ;
              subwf       bcd1,F            ;
              btfss       bcd2,3            ;
              subwf       bcd2,F            ;
              btfss       bcd3,3            ;
              subwf       bcd3,F            ;
                                            ;
              movlw       0x30              ;
              btfss       bcd1,7            ;
              subwf       bcd1,F            ;
              btfss       bcd2,7            ;
              subwf       bcd2,F            ;
              btfss       bcd3,7            ;
              subwf       bcd3,F            ;
                                            ;
bin2bcd_1     rlf         rezLL,F           ;
              rlf         rezLH,F           ;
              rlf         bcd3,F            ;
              rlf         bcd2,F            ;
              rlf         bcd1,F            ;
              decfsz      shet,F            ;
              goto        adjdec            ;
                                            ;
              movf        bcd3,W            ;     
              andlw       b'00001111'       ; bcd3   edin
              movwf       edin              ;
              
              swapf       bcd3,W            ;    
              andlw       b'00001111'       ; bcd3   desiat
              movwf       desiat            ;

              movf        bcd2,W            ;    
              andlw       b'00001111'       ; bcd2   sotni
              movwf       sotni             ;
              return                        ;  

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;  (MAX7219)  

init_lcd      call        pauslcd           ;   2 
              movlw       0x0F              ;  
              movwf       adr_ind           ;
              movlw       0x00              ;
              movwf       dat_ind           ;
              call        send              ;

              movlw       0x0C              ; 
              movwf       adr_ind           ;
              movlw       0x01              ;
              movwf       dat_ind           ;
              call        send              ;

              movlw       0x0A              ; 15/32
              movwf       adr_ind           ;
              movlw       0x07              ;
              movwf       dat_ind           ;
              call        send              ;

              movlw       0x09              ; BCD Code B   
              movwf       adr_ind           ;
              movlw       0xFF              ;
              movwf       dat_ind           ;
              call        send              ;

              movlw       0x0B              ; 8 
              movwf       adr_ind           ;
              movlw       0x07              ;
              movwf       dat_ind           ;
              call        send              ;
              return                        ;  

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;  2-    (MAX7219)     SPI

send          bcf         cs                ;    CS
              movlw      .8                 ;    adr_ind
              movwf      scetbit            ;
povtor        bcf        clk                ;
              btfsc      adr_ind,7          ;
              bsf        datai              ;
              btfss      adr_ind,7          ;
              bcf        datai              ;
              bsf        clk                ;
              rlf        adr_ind,F          ;
              decfsz     scetbit,F          ;
              goto       povtor             ;
             
              movlw      .8                 ;    dat_ind
              movwf      scetbit            ;
povtr1        bcf        clk                ;
              btfsc      dat_ind,7          ;
              bsf        datai              ;
              btfss      dat_ind,7          ;
              bcf        datai              ;
              bsf        clk                ;
              rlf        dat_ind,F          ;
              decfsz     scetbit,F          ;
              goto       povtr1             ;
              bcf        clk                ;
              bsf        cs                 ;  1    CS                 
              return                        ;  

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


pauslcd       movlw       .4                ;  2 
              movwf       Sec1              ;
p_l2          movlw       .166              ;
              movwf       Sec               ;
p_l1          decfsz      Sec,F             ;
              goto        p_l1              ;
              decfsz      Sec1,F            ;
              goto        p_l2              ;
              return                        ;  

pause         movlw       .11               ;
              movwf       Sec2              ;
p_3           movlw       .255              ;  2 
              movwf       Sec1              ;
p_1           movlw       .255              ;
              movwf       Sec               ;
p_2           decfsz      Sec,F             ;
              goto        p_2               ;
              decfsz      Sec1,F            ;
              goto        p_1               ;
              decfsz      Sec2,F            ;
              goto        p_3               ;
              return                        ;  
                           
              end                           ;  
                                            ;